// -*- csharp -*-

import std.c.windows.windows;
import std.c.stdlib;
import std.string;
import saori;

extern (C) {
    enum {
        GMEM_FIXED = 0,
        GMEM_MOVEABLE = 2,
        GMEM_MODIFY = 128
    }
}
extern (Windows) {
    export HGLOBAL GlobalFree(HGLOBAL);
    export HGLOBAL GlobalAlloc(UINT,DWORD);
}
extern(C)
BOOL unload()
{
    return saori_unload();
}

extern(C)
BOOL load(HGLOBAL h, long len)
{
    char[] s;
    s.length = len;
    memcpy(cast(char*)s, h, len);
    GlobalFree(h);
    return saori_load(s);
}
extern(C)
HGLOBAL request(HGLOBAL h, long* len)
out(result) {
    assert(result != null);
    assert(*len > 0);
}
body {
    char[] req;
    req.length = *len;
    memcpy(cast(char*)req, h, *len);

    GlobalFree(h);

    char[] res = saori_request(req);

    *len = res.length;
    h = GlobalAlloc(GMEM_FIXED, *len);
    memcpy(h, cast(char*)res, res.length);

    return h;
}

extern (C)
{
    void gc_init();
    void gc_term();
    void _minit();
    void _moduleCtor();
    void _moduleUnitTests();
}

extern (Windows)
BOOL DllMain(HINSTANCE hInstance, ULONG ulReason, LPVOID pvReserved)
{
    switch (ulReason)
      {
      case DLL_PROCESS_ATTACH:
          gc_init();			// GC
          _minit();			// W[Xg
          _moduleCtor();		// W[RXgN^s
          _moduleUnitTests();		// P̃eXgs
          break;

      case DLL_PROCESS_DETACH:
          gc_term();			// GCI
          break;

      case DLL_THREAD_ATTACH:
      case DLL_THREAD_DETACH:
          // }`Xbh͖Ήł
          return false;
      }
//    g_hInst=hInstance;
    return true;
}

